#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "kood.sis";
const char *OUT = "kood.val";

void ERR() {
    printf("400\n");
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

void trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
}

char f1(char c1, char c2) {
    return ((c1 - 'a') + (c2 - 'a')) % 26 + 'a';
}

char f2(char c1, char c2) {
    return (26 - (c1 - 'a') + (c2 - 'a')) % 26 + 'a';
}

char p[250 + 1 + 1];
int k = 0;
bool d;
char s1[250 + 1 + 1], s2[250 + 1 + 1];

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR();
    if (!fgets(p, sizeof(p), in))
        ERR();
    trim(p);
    if (strcmp(p, "KODEERIDA") == 0)
        d = true;
    else if (strcmp(p, "DEKODEERIDA") == 0)
        d = false;
    else
        ERR();
    if (!fgets(p, sizeof(p), in))
        ERR();
    trim(p);
    int n;
    if (fscanf(in, "%d ", &n) != 1)
        ERR();
    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR();

    while (fgets(s1, sizeof(s1), in)) {
        if (!fgets(s2, sizeof(s2), out))
            OK(0, "Enneaegne faili lpp");
        trim(s1); trim(s2);
        for (int i = 0; s1[i]; ++i) {
            char c = s1[i];
            if (c >= 'a' && c <= 'z') {
                c = (d ? f1(p[k], c) : f2(p[k], c));
                if (!p[++k]) k = 0;
            }
            if (s2[i] != c)
                OK(0, "Vale vastus");
        }
        if (s2[strlen(s1)])
            OK(0, "Liigsed smbolid rea lpus");
    }

    char s[10 + 1];
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(in))
        ERR();
    if (fclose(out))
        ERR();
    OK(100, "OK");
}
