// 2005-11-19 programmeerimisvistlus
// lesanne: MITMES NDAL?
// Autor: Kristo Tammeoja
// Testitud: GCC 3.2 / MinGW

#include <stdio.h>
#include <stdlib.h>

const int kuu_pikkus[] = {31, 28,
                          31, 30, 31,
                          30, 31, 31,
                          30, 31, 30,
                          31
                         };

int anna_nadalapaeva_nr(char N) {
    switch (N) {
      case 'E': return 0;
      case 'T': return 1;
      case 'K': return 2;
      case 'N': return 3;
      case 'R': return 4;
      case 'L': return 5;
      case 'P': return 6;
      default:
          fprintf(stderr, "vigane ndalapeva this %c\n", N);
          exit(1);
    }
}

bool on_liigaasta(int aasta) {
    return    aasta % 400 == 0
           || (   aasta % 4 == 0
               && aasta % 100 != 0);
}

int paevi_kuus(int kuu, int aasta) {
    if (kuu == 2) {
        if (on_liigaasta(aasta)) return 29;
        else return 28;
    }
    return kuu_pikkus[kuu-1];
}

int paevi_eelmises_kuus(int kuu, int aasta) {
    if (kuu == 1) {
        kuu = 12;
        aasta = aasta - 1;
    } else {
        kuu = kuu - 1;
    }
    return paevi_kuus(kuu, aasta);
}

int main() {
    FILE *sisf = fopen("nadal.sis", "rt");
    char N;
    int PP, KK, AAAA;
    fscanf(sisf, "%c, %d.%d.%d", &N, &PP, &KK, &AAAA);
    fclose(sisf);

    int esmaspaev_PP;
    esmaspaev_PP = PP - anna_nadalapaeva_nr(N);
    if (esmaspaev_PP <= 0) {
        esmaspaev_PP += paevi_eelmises_kuus(KK, AAAA);
    }
    
    int nadal = (esmaspaev_PP - 1) / 7 + 1;

    FILE *valf = fopen("nadal.val", "wt");
    fprintf(valf, "%d\n", nadal);
    fclose(valf);

    return 0;
}
