#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "parl.sis";
const char *OUT = "parl.val";
const int MAX = 1000;

void ERR() {
    printf("400\n");
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

int n, m, k;
int v[MAX];
int e[MAX][MAX];

void dfs(int i, int k) {
    v[i] = k;
    for (int j = 0; j < n; ++j)
        if (e[i][j] && !v[j])
            dfs(j, k);
}

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR();
    if (fscanf(in, "%d %d %d", &n, &m, &k) != 3)
        ERR();
    if (fclose(in))
        ERR();

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR();
    int mm = 0;
    char s[20];
    while (fgets(s, sizeof(s), out)) {
        int a, b, c;
        if (sscanf(s, "%d %d %n", &a, &b, &c) != 2)
            OK(0, "Viga tisarvu lugemisel");
        if (c < strlen(s))
            OK(0, "Liigsed smbolid rea lpus");
        if (a < 1 || a > n || b < 1 || b > n)
            OK(0, "Lubamatu prli number");
        --a; --b;
        if (a == b)
            OK(0, "Iseendaga hendatud prl");
        if (e[a][b])
            OK(0, "Korduv hendus");
        ++e[a][b]; ++e[b][a];
        ++mm;
    }
    if (mm != m)
        OK(0, "Vale vljundridade arv");
    if (fclose(out))
        ERR();

    int kk = 0;
    for (int i = 0; i < n; ++i)
        if (!v[i])
            dfs(i, ++kk);
    if (kk != k)
        OK(0, "Vale ehete arv");

    OK(100, "OK");
}
