// 2005-11-19 programmeerimisvistlus
// lesanne: VHIM RIST
// Autor: Ahto Truu
// Testitud: JDK 1.5.0 SE / Win32

import java.io.*;
import java.util.*;

public class ristlah1 {

    static final String SIS = "rist.sis"; // sisendfaili nimi
    static final String VAL = "rist.val"; // vljundfaili nimi

    static int n; // punktide arv
    static int x[], y[]; // punktide koordinaadid

    // kontrollib punktide b ja c omavahelist asendit punkti a poolt vaadates
    // tagastab: +1, kui b on paremal; -1, kui b on vasakul; 0, kui on hel joonel
    static int dir(int a, int b, int c) {
        int cp = (x[b] - x[a]) * (y[c] - y[a]) - (x[c] - x[a]) * (y[b] - y[a]);
        if (cp > 0) return +1;
        if (cp < 0) return -1;
        return 0;
    }

    // kontrollib, kas ligud a-b ja c-d likuvad
    static boolean xing(int a, int b, int c, int d) {
        return
            dir(a, b, c) * dir(a, b, d) < 0 &&
            dir(c, d, a) * dir(c, d, b) < 0;
    }

    // leiab likude a-b ja c-d pikkuste ruutude summa
    static int size(int a, int b, int c, int d) {
        return
            (x[b] - x[a]) * (x[b] - x[a]) + (y[b] - y[a]) * (y[b] - y[a]) +
            (x[d] - x[c]) * (x[d] - x[c]) + (y[d] - y[c]) * (y[d] - y[c]);
    }

    public static void main(String[] args) throws IOException {
        // loeme sisendandmed
        BufferedReader sis = new BufferedReader(new FileReader(SIS));
        n = Integer.parseInt(sis.readLine());
        x = new int[n]; y = new int[n];
        for (int i = 0; i < n; ++i) {
            StringTokenizer s = new StringTokenizer(sis.readLine());
            x[i] = Integer.parseInt(s.nextToken());
            y[i] = Integer.parseInt(s.nextToken());
        }

        // leiame vastuse, vaadates lbi kik punktinelikud
        int aa = 0, bb = 0, cc = 0, dd = 0, ss = -1;
        for (int a = 0; a < n; ++a)
            for (int b = a + 1; b < n; ++b)
                for (int c = a + 1; c < n; ++c)
                    for (int d = c + 1; d < n; ++d) {
                        int s = size(a, b, c, d);
                        if (ss < 0 || ss > s)
                            if (xing(a, b, c, d)) {
                                aa = a; bb = b; cc = c; dd = d; ss = s;
                            }
                    }

        // vljastame vastuse
        PrintWriter val = new PrintWriter(new FileWriter(VAL));
        ++aa; ++bb; ++cc; ++dd;
        val.println(aa + " " + bb);
        val.println(cc + " " + dd);
        val.close();
    }
}
