#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "rist.sis";
const char *OUT = "rist.val";
const int MAX = 1000;

void ERR() {
    printf("400\n");
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

int n;
int x[MAX], y[MAX];
int ss;
int a, b, c, d;

int dir(int a, int b, int c) {
    int cp = (x[b] - x[a]) * (y[c] - y[a]) - (x[c] - x[a]) * (y[b] - y[a]);
    if (cp > 0) return +1;
    if (cp < 0) return -1;
    return 0;
}

bool xing(int a, int b, int c, int d) {
    return
        dir(a, b, c) * dir(a, b, d) < 0 &&
        dir(c, d, a) * dir(c, d, b) < 0;
}

int size(int a, int b, int c, int d) {
    return
        (x[b] - x[a]) * (x[b] - x[a]) + (y[b] - y[a]) * (y[b] - y[a]) +
        (x[d] - x[c]) * (x[d] - x[c]) + (y[d] - y[c]) * (y[d] - y[c]);
}

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR();
    if (fscanf(in, "%d ", &n) != 1)
        ERR();
    for (int i = 0; i < n; ++i)
        if (fscanf(in, "%d %d ", &x[i], &y[i]) != 2)
            ERR();
    if (fclose(in))
        ERR();

    ss = -1;
    for (a = 0; a < n; ++a)
        for (b = a + 1; b < n; ++b)
            for (c = a + 1; c < n; ++c)
                for (d = c + 1; d < n; ++d) {
                    int s = size(a, b, c, d);
                    if (ss < 0 || ss > s)
                        if (xing(a, b, c, d))
                            ss = s;
                }

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR();
    char s[20];
    int u;
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    if (sscanf(s, "%d %d %n", &a, &b, &u) != 2)
        OK(0, "Viga tisarvu lugemisel");
    if (u < strlen(s))
        OK(0, "Liigsed smbolid rea lpus");
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    if (sscanf(s, "%d %d %n", &c, &d, &u) != 2)
        OK(0, "Viga tisarvu lugemisel");
    if (u < strlen(s))
        OK(0, "Liigsed smbolid rea lpus");
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR();

    if (a < 1 || a > n || b < 1 || b > n || c < 1 || c > n || d < 1 || d > n)
        OK(0, "Lubamatu punkti number");
    --a; --b; --c; --d;
    if (a == b || a == c || a == d || b == c || b == d || c == d)
        OK(0, "Korduv punkt");
    if (!xing(a, b, c, d))
        OK(0, "Ligud ei liku");
    if (ss < size(a, b, c, d))
        OK(0, "Rist pole minimaalne");

    OK(100, "OK");
}
