// 2005-11-19 programmeerimisvistlus
// lesanne: TEEDEKAART
// Autor: Kristo Tammeoja
// Testitud: GCC 3.2 / MinGW

// Kasutab Floyd-Warshalli algoritmi
// Ajaline keerukus N^3
// Maksimaalses testis liiga aeglane

#include <stdio.h>
#include <time.h>

// 2*SUUR_ARV mahub veel int-i ra
#define SUUR_ARV 1000000000

#define MAX_N 1000
#define MAX_M 10000

int N, M;
int min_d[MAX_N+1];
int max_d[MAX_N+1];
int kaugus[MAX_N+1][MAX_N+1];

void loe_teed() {
    FILE *sisf;
    sisf = fopen("teed.sis", "rt");

    fscanf(sisf, "%d %d", &N, &M);
    for (int j = 1; j <= N; j++)
        for (int k = 1; k <= N; k++)
            kaugus[j][k] = SUUR_ARV;

    int l_1, l_2, d;
    for (int i = 0; i < M; i++) {
        fscanf(sisf, "%d %d %d", &l_1, &l_2, &d);
        kaugus[l_1][l_2] = d;
        kaugus[l_2][l_1] = d;
    }

    for (int j = 1; j <= N; j++) 
        kaugus[j][j] = 0;

    fclose(sisf);
}

void arvuta_kaugused() {
    for (int i = 1; i <= N; i++)
        for (int j = 1; j <= N; j++)
            for (int k = 1; k <= N; k++) {
                int kaugus_labi_i = kaugus[j][i] + kaugus[i][k];
                if (kaugus_labi_i < kaugus[j][k]) kaugus[j][k] = kaugus_labi_i;
            }
}

void leia_vastus() {
    for (int l = 1; l <= N; l++) {
        int min_kaugus = SUUR_ARV;
        int max_kaugus = -1;
        for (int i = 1; i <= N; i++) {
            if (i == l) continue;
            int kaugus_i = kaugus[l][i];
            if (kaugus_i < min_kaugus) min_kaugus = kaugus_i;
            if (max_kaugus < kaugus_i) max_kaugus = kaugus_i;
        }
        min_d[l] = min_kaugus;
        max_d[l] = max_kaugus;
    }
}

void kirjuta_vastus() {
    FILE *valf;
    valf = fopen("teed.val", "wt");
    for (int l = 1; l <= N; l++) {
if (max_d[l] >= SUUR_ARV) fprintf(stdout, "teede graaf pole sidus\n");
        fprintf(valf, "%d %d\n", min_d[l], max_d[l]);
    }
    fclose(valf);
}

int main() {
    loe_teed();
    arvuta_kaugused();
    leia_vastus();
    kirjuta_vastus();
//printf("aeg = %f\n", (float)clock() / CLK_TCK);
    return 0;
}
