#include <stdio.h>
#include <stdlib.h>

bool on_serv[1001][1001];

void init_on_serv() {
    for (int i = 0; i <= 1000; i++)
        for (int j = 0; j <= 1000; j++)
            on_serv[i][j] = false;
}

void fatal(char* s) {
    printf("%s\n", s);
    getc(stdin);
    exit(1);
}

void kirjuta_pais(FILE *fail, int n, int m) {
    if (n < 2 || 1000 < n) fatal("n vigane");
    if (m < 1 || 10000 < m) fatal("m vigane");
    fprintf(fail, "%d %d\n", n, m);
}

void kirjuta_serv(FILE *fail, int n, int a, int b, int d) {
    if (a < 1 || n < a) fatal("a vigane");
    if (b < 1 || n < b) fatal("b vigane");
    if (a == b) fatal("a ja b vrdsed");
    if (on_serv[a][b]) fatal("serv olemas");
    if (d < 1 || 1000 < d) fatal("d vigane");
    on_serv[a][b] = true;
    on_serv[b][a] = true;
    fprintf(fail, "%d %d %d\n", a, b, d);
}

void gen() {
printf("#\n");
    init_on_serv();
    FILE* vfail = fopen("teed__w.sis", "wt");
if (vfail == NULL) fatal("waf");
    int n, m; n = 2; m = 1;
    kirjuta_pais(vfail, n, m);
    kirjuta_serv(vfail, n, 1, 2, 1);
    fclose(vfail);
}

void gen_a() {
printf("#a\n");
    init_on_serv();
    FILE* vfail = fopen("teed__a.sis", "wt");
    int n, m; n = 10; m = 15;
    kirjuta_pais(vfail, n, m);

    kirjuta_serv(vfail, n,1,3,3);
    kirjuta_serv(vfail, n,1,4,3);
    kirjuta_serv(vfail, n,2,4,3);
    kirjuta_serv(vfail, n,2,5,3);
    kirjuta_serv(vfail, n,3,5,3);

    kirjuta_serv(vfail, n,6,7,2);
    kirjuta_serv(vfail, n,7,8,2);
    kirjuta_serv(vfail, n,8,9,2);
    kirjuta_serv(vfail, n,9,10,2);
    kirjuta_serv(vfail, n,10,6,2);

    kirjuta_serv(vfail, n,1,6,1);
    kirjuta_serv(vfail, n,2,7,2);
    kirjuta_serv(vfail, n,3,8,3);
    kirjuta_serv(vfail, n,4,9,4);
    kirjuta_serv(vfail, n,5,10,5);

    fclose(vfail);
}

void gen_b() {
printf("#b\n");
    init_on_serv();
    FILE* vfail = fopen("teed__b.sis", "wt");
    int n, m; n = 15; m = 18;
    kirjuta_pais(vfail, n, m);
    kirjuta_serv(vfail, n, 1, 2, 1);
    kirjuta_serv(vfail, n, 2, 3, 2);
    kirjuta_serv(vfail, n, 3, 4, 1);
    kirjuta_serv(vfail, n, 1, 4, 2);
    kirjuta_serv(vfail, n, 14, 6, 3);
    kirjuta_serv(vfail, n, 6, 7, 1);
    kirjuta_serv(vfail, n, 7, 8, 3);
    kirjuta_serv(vfail, n, 8, 9, 1);
    kirjuta_serv(vfail, n, 9, 10, 1);
    kirjuta_serv(vfail, n, 10, 11, 1);
    kirjuta_serv(vfail, n, 11, 12, 2);
    kirjuta_serv(vfail, n, 12, 13, 1);
    kirjuta_serv(vfail, n, 13, 14, 1);
    kirjuta_serv(vfail, n, 14, 15, 3);
    kirjuta_serv(vfail, n, 15, 3, 1);
    kirjuta_serv(vfail, n, 4, 5, 1);
    kirjuta_serv(vfail, n, 5, 6, 3);
    kirjuta_serv(vfail, n, 9, 12, 1);
    fclose(vfail);
}

void gen_c() {
printf("#c\n");
    init_on_serv();
    FILE* vfail = fopen("teed__c.sis", "wt");
    int n, m; n = 25; m = 30;
    kirjuta_pais(vfail, n, m);
    int ml = 0;
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            kirjuta_serv(vfail, n, 5*i+j+1, 5*i+ (j+1) % 5 +1, 1);
            ml++;
        }
        kirjuta_serv(vfail, n, 5*i+2, 5* ((i+1) % 5) +1, 1);
        ml++;
    }
if (ml != m) fatal("c vigane...");
    fclose(vfail);
}

void gen_d() {
printf("#d\n");
    init_on_serv();
    FILE* vfail = fopen("teed__d.sis", "wt");
    int n, m; n = 25; m = 55;
    kirjuta_pais(vfail, n, m);
    int ml = 0;
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++)
            for (int k = j+1; k < 5; k++) {
                kirjuta_serv(vfail, n, 5*i+j+1, 5*i+k+1, 1);
                ml++;
            }
        kirjuta_serv(vfail, n, 5*i+2, 5* ((i+1) % 5) +1, 1);
        ml++;
    }
if (ml != m) fatal("d vigane...");
    fclose(vfail);
}

void gen_e() {
printf("#e\n");
    init_on_serv();
    FILE* vfail = fopen("teed__e.sis", "wt");
    int n, m; n = 100; m = 99;
    kirjuta_pais(vfail, n, m);
    for (int i = 1; i <= m; i++)
        kirjuta_serv(vfail, n, i, i+1, 1000);
    fclose(vfail);
}

void gen_f() {
printf("#f\n");
    init_on_serv();
    FILE* vfail = fopen("teed__f.sis", "wt");
    int a = 10; int b = 15;
    int n, m; n = a*b; m = a*b+b*(a-1);
    kirjuta_pais(vfail, n, m);
    int ml = 0;
    for (int i = 0; i < a; i++)
        for (int j = 1; j <= b; j++) {
            kirjuta_serv(vfail, n, i*b+j, i*b+(j%b)+1, 3+i);
            ml++;
            if ( i > 0) {
                kirjuta_serv(vfail, n, i*b+j, i*b+j-b, 3+i);
                ml++;
            }
        }
if (ml != m) fatal("f vigane...");
    fclose(vfail);
}

void gen_g() {
printf("#g\n");
    init_on_serv();
    FILE* vfail = fopen("teed__g.sis", "wt");
    int n, m; n = 255; m = 254;
    kirjuta_pais(vfail, n, m);
    int ml = 0;
    for (int i = 1; i < 128; i++) {
        kirjuta_serv(vfail, n, i, 2*i, 10);
        ml++;
        kirjuta_serv(vfail, n, i, 2*i+1, 10);
        ml++;
    }
if (ml != m) fatal("g vigane...");
    fclose(vfail);
}

void gen_h() {
printf("#h\n");
    init_on_serv();
    FILE* vfail = fopen("teed__h.sis", "wt");
    int a = 10; int b = 40;
    int n, m; n = a*b; m = a*b+b*(a-1);
    kirjuta_pais(vfail, n, m);
    int ml = 0;
    for (int i = 0; i < a; i++)
        for (int j = 1; j <= b; j++) {
            kirjuta_serv(vfail, n, i*b+j, i*b+(j%b)+1, 3+i);
            ml++;
            if ( i > 0) {
                kirjuta_serv(vfail, n, i*b+j, i*b+j-b, 3+i);
                ml++;
            }
        }
if (ml != m) fatal("h vigane...");
    fclose(vfail);
}

void gen_i() {
printf("#i\n");
    init_on_serv();
    FILE* vfail = fopen("teed__i.sis", "wt");
    int a = 31; 
    int b = 32;
//a = 3; b = 5;
    int n, m;
    n = a * b;
    m = (a-1)*b+a*(b-1);
    kirjuta_pais(vfail, n, m);
    int e = 0;
    int v = 0;
    for (int j = 1; j <= a; j++) {
        for (int i = 1; i <= b; i++) {
            v++;
            if (i < b) {
                kirjuta_serv(vfail, n, v, v+1, 1);
                e++;
            }
            if (j < a) {
                kirjuta_serv(vfail, n, v, v+b, 1);
                e++;
            }
        }
    }
    if (e != m) fatal("i e!=m");
    fclose(vfail);
}

void gen_j() {
printf("#j\n");
    init_on_serv();
    FILE* vfail = fopen("teed__j.sis", "wt");
    int n, m; n = 1000; m = 10000;
    kirjuta_pais(vfail, n, m);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= 10; j++) {
            kirjuta_serv(vfail, n, i, (i-1+j) % n + 1, 10+j*10);
        }
    fclose(vfail);
}

int main() {
    gen();
    gen_a();
    gen_b();
    gen_c();
    gen_d();
    gen_e();
    gen_f();
    gen_g();
    gen_h();
    gen_i();
    gen_j();
    return 0;
}
